/* $Id: sh3mon.c,v 1.5 1999/09/02 10:12:28 stuart Exp $
 *
 * sh3mon/sh3mon.c
 *
 * Copyright (C) 1999 Stuart Menefy
 */

#include <stdio.h>
#include <string.h>
#ifndef LINUX
#include <stdlib.h>
#else
#include <getopt.h>
#endif
#define EXTERN
#include "sh3mon.h"

#ifndef LINUX
#define DEFAULT_DEVICE "/dev/cua/b"
#else
#define DEFAULT_DEVICE "/dev/ttyS1"
#endif
#define DEFAULT_FILENAME "a.out"

extern char *optarg;
extern int optind;

static void
usage(void)
{
  fprintf(stderr, "Usage: %s [-n] [-v] [-d device] [executable]\n", program_name);
  exit(1);
}

int
main(int argc, char *argv[])
{
  const char *load_filename = DEFAULT_FILENAME;
  const char *dev_filename = DEFAULT_DEVICE;
  int c;
  unsigned long entry;
  int run = 1;

  verbose = 0;
  program_name = strrchr(argv[0], '/');
  if (program_name == NULL)
    program_name = argv[0];
  else
    program_name++;

  while ((c = getopt(argc, argv, "d:nv")) != EOF) {
    switch (c) {
    case 'd':
      dev_filename = optarg;
      break;
    case 'n':
      run = 0;
      break;
    case 'v':
      verbose = 1;
      break;
    default:
      usage();
    }
  }

  if (optind == argc-1)
    load_filename = argv[optind];
  else if (optind != argc) {
    fprintf(stderr, "Too many filenames\n");
    usage();
  }

  sh3eva_open(dev_filename);
  load_open(load_filename);

  sh3eva_connect();
  entry = load_write(sh3eva_write);

  if (!run)
    return 0;

  sh3eva_run(entry);
  load_close();

  sh3eva_terminal();
  
  return 0;
}
